<html>
<head>
<title>Ogre::RTShader::CGProgramWriter Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="namespaceOgre_1_1RTShader.html">RTShader</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1RTShader_1_1CGProgramWriter.html">CGProgramWriter</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-attribs">Static Public Attributes</a> &#124;
<a href="#pro-types">Protected Types</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::RTShader::CGProgramWriter Class Reference<div class="ingroups"><a class="el" href="group__RTShader.html">RTShader</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::RTShader::CGProgramWriter" --><!-- doxytag: inherits="Ogre::RTShader::ProgramWriter" -->
<p>CG target language writer implementation.  
 <a href="classOgre_1_1RTShader_1_1CGProgramWriter.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreShaderCGProgramWriter_8h_source.html">OgreShaderCGProgramWriter.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::RTShader::CGProgramWriter:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1RTShader_1_1CGProgramWriter__inherit__graph.gif" border="0" usemap="#Ogre_1_1RTShader_1_1CGProgramWriter_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1RTShader_1_1CGProgramWriter_inherit__map" id="Ogre_1_1RTShader_1_1CGProgramWriter_inherit__map">
<area shape="rect" id="node2" href="classOgre_1_1RTShader_1_1ProgramWriter.html" title="Base class interface for shader program writers." alt="" coords="16,83,224,112"/><area shape="rect" id="node4" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator..." alt="" coords="43,5,197,35"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1RTShader_1_1CGProgramWriter-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a9721e3cabbf137877922b7485046124b">CGProgramWriter</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Class constructor.  <a href="#a9721e3cabbf137877922b7485046124b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a2813ee70b92380ef48c5056ff623213f">~CGProgramWriter</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Class destructor.  <a href="#a2813ee70b92380ef48c5056ff623213f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a9279b53602e0be2183bd0452ed830c50">writeSourceCode</a> (std::ostream &amp;os, <a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> *program)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#aebc63f8a4ec1ef6d0985621902140089">getTargetLanguage</a> () const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html#a2dedd0d346cf93b37f379e35775d4e20">writeSourceCode</a> (<a class="el" href="classOgre_1_1StringSerialiser.html">StringSerialiser</a> &amp;os, <a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> *program)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Write the program shader source code.  <a href="#a2dedd0d346cf93b37f379e35775d4e20"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a421b197ca3a38da17e2eb1531a645fa2">operator new</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">operator new, with debug line info  <a href="#a421b197ca3a38da17e2eb1531a645fa2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ac4bdf968b7b9af8a5239a27da73d5711">operator new</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ab78a921e54419be677839cdf15d1f0b8">operator new</a> (size_t sz, void *ptr)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">placement operator new  <a href="#ab78a921e54419be677839cdf15d1f0b8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a4be37baef81876985aa1071ad5acc6dd">operator new[]</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">array operator new, with debug line info  <a href="#a4be37baef81876985aa1071ad5acc6dd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#afa2943846ba6a2b5824a12857139cf5e">operator new[]</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a8357fe4fb4849772b94baa4bf47c7ded">operator delete</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a1c727e879a260c37b00ce5505fe8e144">operator delete</a> (void *ptr, void *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#acb46d4b0a597156d9ba5abc39d127792">operator delete</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a93e6a86dde5483c053ca0f2a85bbfd6c">operator delete[]</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a595ea4c05da8aa987d3800e65d23355d">operator delete[]</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td colspan="2"><h2><a name="pub-static-attribs"></a>
Static Public Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#ae30fa976742fc69297a072d716987820">TargetLanguage</a></td></tr>
<tr><td colspan="2"><h2><a name="pro-types"></a>
Protected Types</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1map.html">map</a>&lt; <a class="el" href="group__Materials.html#ga9c5b2950be06ff56a6ee0bace240d447">GpuConstantType</a>, <br class="typebreak"/>
const char * &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a15bcc4a4f766470b97509947eebc9a4b">GpuConstTypeToStringMap</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1map.html">map</a><br class="typebreak"/>
&lt; <a class="el" href="classOgre_1_1RTShader_1_1Parameter.html#a91fc3614f191bebf0461676a03750312">Parameter::Semantic</a>, const <br class="typebreak"/>
char * &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a10765b92adccc1bad92a3ea020135a3f">ParamSemanticToStringMap</a></td></tr>
<tr><td colspan="2"><h2><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a4ad5e10d31f62a153038318f8440cc06">initializeStringMaps</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Initialize string maps.  <a href="#a4ad5e10d31f62a153038318f8440cc06"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a7c6ccedfc53a9e5d8ff2a6afa3d011d4">writeProgramDependencies</a> (std::ostream &amp;os, <a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> *program)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Write the program dependencies.  <a href="#a7c6ccedfc53a9e5d8ff2a6afa3d011d4"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a4c20ae91acfd8a643568947f1f9273b4">writeUniformParameter</a> (std::ostream &amp;os, <a class="el" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a> parameter)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Write a uniform parameter.  <a href="#a4c20ae91acfd8a643568947f1f9273b4"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#ae837098712aa6445f4893f13eecb6763">writeFunctionParameter</a> (std::ostream &amp;os, <a class="el" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a> parameter)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Write a function parameter.  <a href="#ae837098712aa6445f4893f13eecb6763"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a7306032b04ed9fabec3461227f88b726">writeLocalParameter</a> (std::ostream &amp;os, <a class="el" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a> parameter)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Write a local parameter.  <a href="#a7306032b04ed9fabec3461227f88b726"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#aa8d1d99980640b7c6be76e95e56edba1">writeFunctionDeclaration</a> (std::ostream &amp;os, <a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a> *function, <a class="el" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a> &amp;colorParameter)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Write a function declaration.  <a href="#aa8d1d99980640b7c6be76e95e56edba1"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a6da4c6c68889ef09e2e4eef9cbaa4245">writeAtomInstance</a> (std::ostream &amp;os, <a class="el" href="classOgre_1_1RTShader_1_1FunctionAtom.html">FunctionAtom</a> *atom)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Write function atom instance.  <a href="#a6da4c6c68889ef09e2e4eef9cbaa4245"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html#ab1b6c67defa74dfdce8a0bcd1ccb62cb">writeProgramTitle</a> (<a class="el" href="classOgre_1_1StringSerialiser.html">StringSerialiser</a> &amp;os, <a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> *program)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Write the program title.  <a href="#ab1b6c67defa74dfdce8a0bcd1ccb62cb"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html#a9503345c6d319c8c39cdb1f8c83f10a0">writeUniformParametersTitle</a> (<a class="el" href="classOgre_1_1StringSerialiser.html">StringSerialiser</a> &amp;os, <a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> *program)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Write the uniform parameters title.  <a href="#a9503345c6d319c8c39cdb1f8c83f10a0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html#a6417dc1c4838e8df26e98b3c675ec26f">writeFunctionTitle</a> (<a class="el" href="classOgre_1_1StringSerialiser.html">StringSerialiser</a> &amp;os, <a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a> *function)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Write a function title.  <a href="#a6417dc1c4838e8df26e98b3c675ec26f"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a15bcc4a4f766470b97509947eebc9a4b">GpuConstTypeToStringMap</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a5a58fdcb44c6559c31e2007d942da9b9">mGpuConstTypeMap</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a10765b92adccc1bad92a3ea020135a3f">ParamSemanticToStringMap</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a22775b23abba17b8797238e1a227703e">mParamSemanticMap</a></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>CG target language writer implementation. </p>
<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html" title="Base class interface for shader program writers.">ProgramWriter</a>. </dd></dl>

<p>Definition at line <a class="el" href="OgreShaderCGProgramWriter_8h_source.html#l00046">46</a> of file <a class="el" href="OgreShaderCGProgramWriter_8h_source.html">OgreShaderCGProgramWriter.h</a>.</p>
</div><hr/><h2>Member Typedef Documentation</h2>
<a class="anchor" id="a15bcc4a4f766470b97509947eebc9a4b"></a><!-- doxytag: member="Ogre::RTShader::CGProgramWriter::GpuConstTypeToStringMap" ref="a15bcc4a4f766470b97509947eebc9a4b" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1map.html">map</a>&lt;<a class="el" href="group__Materials.html#ga9c5b2950be06ff56a6ee0bace240d447">GpuConstantType</a>, const char*&gt;::type <a class="el" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a15bcc4a4f766470b97509947eebc9a4b">Ogre::RTShader::CGProgramWriter::GpuConstTypeToStringMap</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderCGProgramWriter_8h_source.html#l00098">98</a> of file <a class="el" href="OgreShaderCGProgramWriter_8h_source.html">OgreShaderCGProgramWriter.h</a>.</p>

</div>
</div>
<a class="anchor" id="a10765b92adccc1bad92a3ea020135a3f"></a><!-- doxytag: member="Ogre::RTShader::CGProgramWriter::ParamSemanticToStringMap" ref="a10765b92adccc1bad92a3ea020135a3f" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1map.html">map</a>&lt;<a class="el" href="classOgre_1_1RTShader_1_1Parameter.html#a91fc3614f191bebf0461676a03750312">Parameter::Semantic</a>, const char*&gt;::type <a class="el" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a10765b92adccc1bad92a3ea020135a3f">Ogre::RTShader::CGProgramWriter::ParamSemanticToStringMap</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderCGProgramWriter_8h_source.html#l00099">99</a> of file <a class="el" href="OgreShaderCGProgramWriter_8h_source.html">OgreShaderCGProgramWriter.h</a>.</p>

</div>
</div>
<hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a9721e3cabbf137877922b7485046124b"></a><!-- doxytag: member="Ogre::RTShader::CGProgramWriter::CGProgramWriter" ref="a9721e3cabbf137877922b7485046124b" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a9721e3cabbf137877922b7485046124b">Ogre::RTShader::CGProgramWriter::CGProgramWriter</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Class constructor. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">language</td><td>The target shader language. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a2813ee70b92380ef48c5056ff623213f"></a><!-- doxytag: member="Ogre::RTShader::CGProgramWriter::~CGProgramWriter" ref="a2813ee70b92380ef48c5056ff623213f" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a2813ee70b92380ef48c5056ff623213f">Ogre::RTShader::CGProgramWriter::~CGProgramWriter</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Class destructor. </p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="aebc63f8a4ec1ef6d0985621902140089"></a><!-- doxytag: member="Ogre::RTShader::CGProgramWriter::getTargetLanguage" ref="aebc63f8a4ec1ef6d0985621902140089" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="el" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#aebc63f8a4ec1ef6d0985621902140089">Ogre::RTShader::CGProgramWriter::getTargetLanguage</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html#adea123814282cb2fd21f504246647b06" title="Return the target language of this writer.">ProgramWriter::getTargetLanguage</a>. </dd></dl>

<p>Implements <a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html#adea123814282cb2fd21f504246647b06">Ogre::RTShader::ProgramWriter</a>.</p>

<p>Definition at line <a class="el" href="OgreShaderCGProgramWriter_8h_source.html#l00068">68</a> of file <a class="el" href="OgreShaderCGProgramWriter_8h_source.html">OgreShaderCGProgramWriter.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4ad5e10d31f62a153038318f8440cc06"></a><!-- doxytag: member="Ogre::RTShader::CGProgramWriter::initializeStringMaps" ref="a4ad5e10d31f62a153038318f8440cc06" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a4ad5e10d31f62a153038318f8440cc06">Ogre::RTShader::CGProgramWriter::initializeStringMaps</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Initialize string maps. </p>

</div>
</div>
<a class="anchor" id="a8357fe4fb4849772b94baa4bf47c7ded"></a><!-- doxytag: member="Ogre::RTShader::CGProgramWriter::operator delete" ref="a8357fe4fb4849772b94baa4bf47c7ded" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00095">95</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1c727e879a260c37b00ce5505fe8e144"></a><!-- doxytag: member="Ogre::RTShader::CGProgramWriter::operator delete" ref="a1c727e879a260c37b00ce5505fe8e144" args="(void *ptr, void *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00101">101</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="acb46d4b0a597156d9ba5abc39d127792"></a><!-- doxytag: member="Ogre::RTShader::CGProgramWriter::operator delete" ref="acb46d4b0a597156d9ba5abc39d127792" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00107">107</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a93e6a86dde5483c053ca0f2a85bbfd6c"></a><!-- doxytag: member="Ogre::RTShader::CGProgramWriter::operator delete[]" ref="a93e6a86dde5483c053ca0f2a85bbfd6c" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00112">112</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a595ea4c05da8aa987d3800e65d23355d"></a><!-- doxytag: member="Ogre::RTShader::CGProgramWriter::operator delete[]" ref="a595ea4c05da8aa987d3800e65d23355d" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00118">118</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a421b197ca3a38da17e2eb1531a645fa2"></a><!-- doxytag: member="Ogre::RTShader::CGProgramWriter::operator new" ref="a421b197ca3a38da17e2eb1531a645fa2" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00067">67</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac4bdf968b7b9af8a5239a27da73d5711"></a><!-- doxytag: member="Ogre::RTShader::CGProgramWriter::operator new" ref="ac4bdf968b7b9af8a5239a27da73d5711" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00072">72</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab78a921e54419be677839cdf15d1f0b8"></a><!-- doxytag: member="Ogre::RTShader::CGProgramWriter::operator new" ref="ab78a921e54419be677839cdf15d1f0b8" args="(size_t sz, void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>placement operator new </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00078">78</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4be37baef81876985aa1071ad5acc6dd"></a><!-- doxytag: member="Ogre::RTShader::CGProgramWriter::operator new[]" ref="a4be37baef81876985aa1071ad5acc6dd" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>array operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00085">85</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="afa2943846ba6a2b5824a12857139cf5e"></a><!-- doxytag: member="Ogre::RTShader::CGProgramWriter::operator new[]" ref="afa2943846ba6a2b5824a12857139cf5e" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00090">90</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a6da4c6c68889ef09e2e4eef9cbaa4245"></a><!-- doxytag: member="Ogre::RTShader::CGProgramWriter::writeAtomInstance" ref="a6da4c6c68889ef09e2e4eef9cbaa4245" args="(std::ostream &amp;os, FunctionAtom *atom)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a6da4c6c68889ef09e2e4eef9cbaa4245">Ogre::RTShader::CGProgramWriter::writeAtomInstance</a> </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&#160;</td>
          <td class="paramname"><em>os</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1FunctionAtom.html">FunctionAtom</a> *&#160;</td>
          <td class="paramname"><em>atom</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Write function atom instance. </p>

</div>
</div>
<a class="anchor" id="aa8d1d99980640b7c6be76e95e56edba1"></a><!-- doxytag: member="Ogre::RTShader::CGProgramWriter::writeFunctionDeclaration" ref="aa8d1d99980640b7c6be76e95e56edba1" args="(std::ostream &amp;os, Function *function, ParameterPtr &amp;colorParameter)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#aa8d1d99980640b7c6be76e95e56edba1">Ogre::RTShader::CGProgramWriter::writeFunctionDeclaration</a> </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&#160;</td>
          <td class="paramname"><em>os</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a> *&#160;</td>
          <td class="paramname"><em>function</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a> &amp;&#160;</td>
          <td class="paramname"><em>colorParameter</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Write a function declaration. </p>

</div>
</div>
<a class="anchor" id="ae837098712aa6445f4893f13eecb6763"></a><!-- doxytag: member="Ogre::RTShader::CGProgramWriter::writeFunctionParameter" ref="ae837098712aa6445f4893f13eecb6763" args="(std::ostream &amp;os, ParameterPtr parameter)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#ae837098712aa6445f4893f13eecb6763">Ogre::RTShader::CGProgramWriter::writeFunctionParameter</a> </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&#160;</td>
          <td class="paramname"><em>os</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>&#160;</td>
          <td class="paramname"><em>parameter</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Write a function parameter. </p>

</div>
</div>
<a class="anchor" id="a6417dc1c4838e8df26e98b3c675ec26f"></a><!-- doxytag: member="Ogre::RTShader::CGProgramWriter::writeFunctionTitle" ref="a6417dc1c4838e8df26e98b3c675ec26f" args="(StringSerialiser &amp;os, Function *function)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html#a6417dc1c4838e8df26e98b3c675ec26f">Ogre::RTShader::ProgramWriter::writeFunctionTitle</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1StringSerialiser.html">StringSerialiser</a> &amp;&#160;</td>
          <td class="paramname"><em>os</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a> *&#160;</td>
          <td class="paramname"><em>function</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Write a function title. </p>

</div>
</div>
<a class="anchor" id="a7306032b04ed9fabec3461227f88b726"></a><!-- doxytag: member="Ogre::RTShader::CGProgramWriter::writeLocalParameter" ref="a7306032b04ed9fabec3461227f88b726" args="(std::ostream &amp;os, ParameterPtr parameter)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a7306032b04ed9fabec3461227f88b726">Ogre::RTShader::CGProgramWriter::writeLocalParameter</a> </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&#160;</td>
          <td class="paramname"><em>os</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>&#160;</td>
          <td class="paramname"><em>parameter</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Write a local parameter. </p>

</div>
</div>
<a class="anchor" id="a7c6ccedfc53a9e5d8ff2a6afa3d011d4"></a><!-- doxytag: member="Ogre::RTShader::CGProgramWriter::writeProgramDependencies" ref="a7c6ccedfc53a9e5d8ff2a6afa3d011d4" args="(std::ostream &amp;os, Program *program)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a7c6ccedfc53a9e5d8ff2a6afa3d011d4">Ogre::RTShader::CGProgramWriter::writeProgramDependencies</a> </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&#160;</td>
          <td class="paramname"><em>os</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> *&#160;</td>
          <td class="paramname"><em>program</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Write the program dependencies. </p>

</div>
</div>
<a class="anchor" id="ab1b6c67defa74dfdce8a0bcd1ccb62cb"></a><!-- doxytag: member="Ogre::RTShader::CGProgramWriter::writeProgramTitle" ref="ab1b6c67defa74dfdce8a0bcd1ccb62cb" args="(StringSerialiser &amp;os, Program *program)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html#ab1b6c67defa74dfdce8a0bcd1ccb62cb">Ogre::RTShader::ProgramWriter::writeProgramTitle</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1StringSerialiser.html">StringSerialiser</a> &amp;&#160;</td>
          <td class="paramname"><em>os</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> *&#160;</td>
          <td class="paramname"><em>program</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Write the program title. </p>

</div>
</div>
<a class="anchor" id="a9279b53602e0be2183bd0452ed830c50"></a><!-- doxytag: member="Ogre::RTShader::CGProgramWriter::writeSourceCode" ref="a9279b53602e0be2183bd0452ed830c50" args="(std::ostream &amp;os, Program *program)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a9279b53602e0be2183bd0452ed830c50">Ogre::RTShader::CGProgramWriter::writeSourceCode</a> </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&#160;</td>
          <td class="paramname"><em>os</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> *&#160;</td>
          <td class="paramname"><em>program</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html#a2dedd0d346cf93b37f379e35775d4e20" title="Write the program shader source code.">ProgramWriter::writeSourceCode</a>. </dd></dl>

</div>
</div>
<a class="anchor" id="a2dedd0d346cf93b37f379e35775d4e20"></a><!-- doxytag: member="Ogre::RTShader::CGProgramWriter::writeSourceCode" ref="a2dedd0d346cf93b37f379e35775d4e20" args="(StringSerialiser &amp;os, Program *program)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html#a2dedd0d346cf93b37f379e35775d4e20">Ogre::RTShader::ProgramWriter::writeSourceCode</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1StringSerialiser.html">StringSerialiser</a> &amp;&#160;</td>
          <td class="paramname"><em>os</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> *&#160;</td>
          <td class="paramname"><em>program</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Write the program shader source code. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">os</td><td>The output stream to write to code into. </td></tr>
    <tr><td class="paramname">program</td><td>The source CPU program for the GPU program code. </td></tr>
  </table>
  </dd>
</dl>

<p>Implemented in <a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a87e5c1203bdc1fafb5ca3be4636e5e32">Ogre::RTShader::GLSLESProgramWriter</a>.</p>

</div>
</div>
<a class="anchor" id="a4c20ae91acfd8a643568947f1f9273b4"></a><!-- doxytag: member="Ogre::RTShader::CGProgramWriter::writeUniformParameter" ref="a4c20ae91acfd8a643568947f1f9273b4" args="(std::ostream &amp;os, UniformParameterPtr parameter)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a4c20ae91acfd8a643568947f1f9273b4">Ogre::RTShader::CGProgramWriter::writeUniformParameter</a> </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&#160;</td>
          <td class="paramname"><em>os</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>&#160;</td>
          <td class="paramname"><em>parameter</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Write a uniform parameter. </p>

</div>
</div>
<a class="anchor" id="a9503345c6d319c8c39cdb1f8c83f10a0"></a><!-- doxytag: member="Ogre::RTShader::CGProgramWriter::writeUniformParametersTitle" ref="a9503345c6d319c8c39cdb1f8c83f10a0" args="(StringSerialiser &amp;os, Program *program)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html#a9503345c6d319c8c39cdb1f8c83f10a0">Ogre::RTShader::ProgramWriter::writeUniformParametersTitle</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1StringSerialiser.html">StringSerialiser</a> &amp;&#160;</td>
          <td class="paramname"><em>os</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> *&#160;</td>
          <td class="paramname"><em>program</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Write the uniform parameters title. </p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="a5a58fdcb44c6559c31e2007d942da9b9"></a><!-- doxytag: member="Ogre::RTShader::CGProgramWriter::mGpuConstTypeMap" ref="a5a58fdcb44c6559c31e2007d942da9b9" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a15bcc4a4f766470b97509947eebc9a4b">GpuConstTypeToStringMap</a> <a class="el" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a5a58fdcb44c6559c31e2007d942da9b9">Ogre::RTShader::CGProgramWriter::mGpuConstTypeMap</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderCGProgramWriter_8h_source.html#l00103">103</a> of file <a class="el" href="OgreShaderCGProgramWriter_8h_source.html">OgreShaderCGProgramWriter.h</a>.</p>

</div>
</div>
<a class="anchor" id="a22775b23abba17b8797238e1a227703e"></a><!-- doxytag: member="Ogre::RTShader::CGProgramWriter::mParamSemanticMap" ref="a22775b23abba17b8797238e1a227703e" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a10765b92adccc1bad92a3ea020135a3f">ParamSemanticToStringMap</a> <a class="el" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a22775b23abba17b8797238e1a227703e">Ogre::RTShader::CGProgramWriter::mParamSemanticMap</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderCGProgramWriter_8h_source.html#l00104">104</a> of file <a class="el" href="OgreShaderCGProgramWriter_8h_source.html">OgreShaderCGProgramWriter.h</a>.</p>

</div>
</div>
<a class="anchor" id="ae30fa976742fc69297a072d716987820"></a><!-- doxytag: member="Ogre::RTShader::CGProgramWriter::TargetLanguage" ref="ae30fa976742fc69297a072d716987820" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="el" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#ae30fa976742fc69297a072d716987820">Ogre::RTShader::CGProgramWriter::TargetLanguage</a><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderCGProgramWriter_8h_source.html#l00070">70</a> of file <a class="el" href="OgreShaderCGProgramWriter_8h_source.html">OgreShaderCGProgramWriter.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreShaderCGProgramWriter_8h_source.html">OgreShaderCGProgramWriter.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:31
</p>
</body>
</html>
